"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var react_i18next_1 = require("react-i18next");
var yup_1 = require("yup");
var core_1 = require("@reactionable/core");
var ModalForm_1 = require("../../../modal-form/ModalForm");
var Form_1 = require("../../../form/Form");
;
exports.useAuthenticator = function () {
    var t = react_i18next_1.useTranslation().t;
    var _a = core_1.useIdentityContext(), login = _a.login, logout = _a.logout, setUser = _a.setUser, user = _a.user;
    var modal = ModalForm_1.useModalForm({
        title: t('Sign Up / Sign In'),
        submitButton: t('Sign In'),
        formValues: { email: '', password: '', remember: true },
        onSubmit: function (values, actions) { return __awaiter(void 0, void 0, void 0, function () {
            var user;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, login(values)];
                    case 1:
                        user = _a.sent();
                        setUser(user);
                        return [2 /*return*/, user];
                }
            });
        }); },
        formSchema: {
            email: yup_1.string()
                .email()
                .required(t('Email is required')),
            password: yup_1.string()
                .required(t('Password is required')),
        },
        render: function (formikBag, isLoading) { return react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(Form_1.FormField, { name: "email", label: t('Email') }),
            react_1.default.createElement(Form_1.FormField, { name: "email", 
                // type="password"
                label: t('Email') })); },
    }).modal;
    return {
        open: open,
        close: close,
        modal: modal,
        user: user,
        logout: logout,
    };
};
//# sourceMappingURL=Authenticator.js.map